// richedView.h : interface of the CRichSyntaxView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_RICHEDVIEW_H__A2BFB415_31B7_11D3_AEC8_08003689AE03__INCLUDED_)
#define AFX_RICHEDVIEW_H__A2BFB415_31B7_11D3_AEC8_08003689AE03__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <afxtempl.h>
class CRichedCntrItem;

class CRichSyntaxView : public CRichEditView
{
protected: // create from serialization only
	CRichSyntaxView();
	CRichSyntaxView(bool caseSensitive, COLORREF keyword, COLORREF userword, COLORREF comment);
	DECLARE_DYNCREATE(CRichSyntaxView)
// Attributes
public:
//	CRichedDoc* GetDocument();

// Operations
public:
	COLORREF USER_DEFINED, COMMENT, KEYWORD;
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRichSyntaxView)
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	void OnPaste();
	void ResetRange(int iMin, int iMax);
	bool IsComment(CString word);
	bool IsKeyWord(CString word);
	bool IsUserDefined(CString word);
	bool LoadKeyWordFile(CString word);
	bool LoadKeyWordFile(CStdioFile& file);
	void AddComment(LPCTSTR key);
	void AddKeyWord(LPCTSTR key);
	void AddUserDefined(LPCTSTR key);
	void Parse();
	void ParseRange(int iMin, int iMax);
	void ParseComment(int iMin, int iMax);
	void SetFileName(CString word);
	void OnSave();
	void OnOpen();
	virtual ~CRichSyntaxView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	CList <CString, LPCTSTR> keyWords, userDefined, comment;
	CString sFileName;
	bool IsWhiteSpace(char c);
	bool CompareFormat(int iMin, int iMax);
	void FindComment();
	void FindWord();
	int iLastWord[2], iLastComment[3];
	bool bCaseSensitive;
	//{{AFX_MSG(CRichSyntaxView)
	afx_msg void OnDestroy();
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RICHEDVIEW_H__A2BFB415_31B7_11D3_AEC8_08003689AE03__INCLUDED_)
